using FluentValidation;

namespace cuqmbr.TravelGuide.Application.Common.FluentValidation;

public static class CustomValidators
{
    // According to RFC 5321.
    public static IRuleBuilderOptions<T, string> IsEmail<T>(
        this IRuleBuilder<T, string> ruleBuilder)
    {
        return
            ruleBuilder
                .Matches(@"^[\w\.-]{1,64}@[\w\.-]{1,251}\.\w{2,4}$");
    }

    // According to ITU-T E.164, no spaces.
    public static IRuleBuilderOptions<T, string> IsPhoneNumber<T>(
        this IRuleBuilder<T, string> ruleBuilder)
    {
        return
            ruleBuilder
                .Matches(@"^\+[0-9]{7,15}$");
    }
}
