using cuqmbr.TravelGuide.Domain.Enums;
using Microsoft.EntityFrameworkCore;
using cuqmbr.TravelGuide.Persistence.TypeConverters;

namespace cuqmbr.TravelGuide.Persistence.InMemory;

public class InMemoryDbContext : DbContext
{
    public InMemoryDbContext(DbContextOptions<InMemoryDbContext> options)
        : base(options) { }

    protected override void OnModelCreating(ModelBuilder builder)
    {
        base.OnModelCreating(builder);
    }

    protected override void ConfigureConventions(
        ModelConfigurationBuilder builder)
    {
        builder
            .Properties<VehicleType>()
            .HaveColumnType("vehicle_type")
            .HaveConversion<VehicleTypeConverter>();

        builder
            .Properties<Currency>()
            .HaveColumnType("currency")
            .HaveConversion<CurrencyConverter>();
    }
}
